<template>
  <div>
    <b-container>
      <b-card id="card">
        <b-card-header class="pt-4" id="header">
          <b-card-title>สมัครสมาชิก</b-card-title>
        </b-card-header>

        <b-card-body ref="b-form-group" @submit.stop.prevent="handleSubmit">
          <b-row class="my-1">
            <b-col sm="6">
              <div class="border">
                <b-card>
                  <b-form-group
                    id="m_User"
                    label="ชื่อผู้ใช้งาน: "
                    label-align-sm="right"
                    label-cols-sm="3"
                    label-for="form-m_User"
                    :valid-feedback="validFeedbackUsername"
                    :invalid-feedback="invalidFeedbackUsername"
                    :state="stateUsername"
                  >
                    <b-form-input
                      id="m_User"
                      size="md"
                      placeholder="ชื่อผู้ใช้งาน"
                      v-model="form.m_User"
                      required
                    >
                    </b-form-input>
                  </b-form-group>

                  <b-form-group
                    id="m_Password"
                    label="รหัสผ่าน: "
                    label-align-sm="right"
                    label-cols-sm="3"
                    label-for="form-m_Password"
                    :valid-feedback="validFeedbackPassword"
                    :invalid-feedback="invalidFeedbackPassword"
                    :state="statePassword"
                  >
                    <b-form-input
                      type="password"
                      id="m_Password"
                      size=""
                      placeholder="รหัสผ่าน"
                      v-model="form.m_Password"
                      required
                    ></b-form-input>
                  </b-form-group>

                  <b-form-group
                    id="Repassword"
                    label="ยืนยันรหัสผ่าน: "
                    label-align-sm="right"
                    label-cols-sm="3"
                    label-for="form-Repassword"
                    :valid-feedback="validFeedbackRepassword"
                    :invalid-feedback="invalidFeedbackRepassword"
                    :state="stateRepassword"
                  >
                    <b-form-input
                      type="password"
                      id="Repassword"
                      size=""
                      placeholder="ยืนยันรหัสผ่าน"
                      v-model="form.Repassword"
                    ></b-form-input>
                  </b-form-group>

                  <b-form-group
                    id="m_Email"
                    label="Email: "
                    label-align-sm="right"
                    label-cols-sm="3"
                    label-for="form-m_Email"
                    :valid-feedback="validFeedbackEmail"
                    :invalid-feedback="invalidFeedbackEmail"
                    :state="stateEmail"
                  >
                    <b-form-input
                      id="m_Email"
                      size=""
                      placeholder="Email"
                      v-model="form.m_Email"
                      required
                    ></b-form-input>
                  </b-form-group>
                </b-card>
              </div>
            </b-col>

            <b-col class="img">
              <div class="Image">
                <b-card>
                  <b-card-img
                    class="ImagePerson"
                    src="https://www.nicepng.com/png/full/192-1921815_-corgi-cartoon-face.png"
                    style="width:90px; height: 100px;"
                  ></b-card-img>
                </b-card>
              </div>
              <br />
              <div class="btnImage">
                <button class="btn btn-info image" style="width: 60%">
                  อัพโหลดรูปภาพ
                </button>
              </div>
              <br />

              <b-form-group
                id="m_Number"
                label="บ้านเลขที่: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-m_Number"
                :valid-feedback="validFeedbackAddress"
                :invalid-feedback="invalidFeedbackAddress"
                :state="stateAddress"
              >
                <b-form-input
                  id="m_Number"
                  size=""
                  placeholder="บ้านเลขที่"
                  v-model="form.m_Address.m_Number"
                  required
                ></b-form-input>
              </b-form-group>

              <b-form-group
                id="m_VillageNo"
                label="หมู่: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-m_VillageNo"
              >
                <b-form-input
                  id="m_VillageNo"
                  size=""
                  placeholder="หมู่"
                  v-model="form.m_Address.m_VillageNo"
                  required
                ></b-form-input>
              </b-form-group>
            </b-col> </b-row
          ><br />

          <b-row class="my-1">
            <b-col sm="6">
              <b-form-group
                id="m_Firstname"
                label="ชื่อ: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-m_Firstname"
                :valid-feedback="validFeedbackName"
                :invalid-feedback="invalidFeedbackName"
                :state="stateName"
              >
                <b-form-input
                  id="m_Firstname"
                  size=""
                  placeholder="ชื่อ"
                  v-model="form.m_Firstname"
                  required
                ></b-form-input>
              </b-form-group>
            </b-col>

            <b-col sm="6">
              <b-form-group
                id="m_Province"
                label="จังหวัด: "
                label-align-sm="right"
                label-for="form-m_Province"
                label-cols-sm="3"
                :valid-feedback="validFeedbackProvince"
                :invalid-feedback="invalidFeedbackProvince"
                :state="stateProvince"
              >
                <b-form-select
                  v-model="form.m_Address.m_Province"
                  :options="province"
                  size="md"
                  id="m_Province"
                  required
                >
                  <b-form-select-option :value="null" disabled
                    >-- กรุณาเลือกจังหวัด --</b-form-select-option
                  >
                </b-form-select>
              </b-form-group>
            </b-col>
          </b-row>

          <b-row class="my-1">
            <b-col sm="6">
              <b-form-group
                id="m_Lastname"
                label="นามสกุล: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-m_Lastname"
                :valid-feedback="validFeedbackSurname"
                :invalid-feedback="invalidFeedbackSurname"
                :state="stateSurname"
              >
                <b-form-input
                  id="m_Lastname"
                  size=""
                  placeholder="นามสกุล"
                  v-model="form.m_Lastname"
                  required
                ></b-form-input>
              </b-form-group>
            </b-col>

            <b-col sm="6">
              <b-form-group
                id="m_District"
                label="เขต/อำเภอ: "
                label-align-sm="right"
                label-for="form-m_District"
                label-cols-sm="3"
                :valid-feedback="validFeedbackDistrict"
                :invalid-feedback="invalidFeedbackDistrict"
                :state="stateDistrict"
              >
                <b-form-select
                  v-model="form.m_Address.m_District"
                  :options="district"
                  size="md"
                  id="m_District"
                  required
                >
                  <b-form-select-option :value="null" disabled
                    >-- เขต/อำเภอ --</b-form-select-option
                  >
                </b-form-select>
              </b-form-group>
            </b-col>
          </b-row>

          <b-row class="my-1">
            <b-col sm="6">
              <b-form-group
                id="m_Birthdate"
                label="วัน/เดือน/ปีเกิด: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-m_Birthdate"
                :valid-feedback="validFeedbackBirthday"
                :invalid-feedback="invalidFeedbackBirthday"
                :state="stateBirthday"
              >
                <div>
                  <b-input-group class="mb-3">
                    <b-form-input
                      id="example-input"
                      v-model="form.m_Birthdate"
                      type="text"
                      placeholder="YYYY-MM-DD"
                      autocomplete="off"
                      required
                    ></b-form-input>
                    <b-input-group-append>
                      <b-form-datepicker
                        v-model="form.m_Birthdate"
                        button-only
                        right
                        locale="en-US"
                        aria-controls="example-input"
                        required
                      ></b-form-datepicker>
                    </b-input-group-append>
                  </b-input-group>
                </div>
              </b-form-group>
            </b-col>
            <br /><br />

            <b-col sm="6">
              <b-form-group
                id="m_SubDistrict"
                label="แขวง/ตำบล: "
                label-align-sm="right"
                label-for="form-m_SubDistrict"
                label-cols-sm="3"
                :valid-feedback="validFeedbackSubdistrict"
                :invalid-feedback="invalidFeedbackSubdistrict"
                :state="stateSubdistrict"
              >
                <b-form-select
                  v-model="form.m_Address.m_SubDistrict"
                  :options="subdistrict"
                  size="md"
                  id="m_SubDistrict"
                  required
                >
                  <b-form-select-option :value="null" disabled
                    >-- แขวง/ตำบล --</b-form-select-option
                  >
                </b-form-select>
              </b-form-group>
            </b-col>
          </b-row>

          <b-row class="my-1">
            <b-col sm="6">
              <b-form-group
                id="m_Nationality"
                label="สัญชาติ: "
                label-align-sm="right"
                label-for="form-m_Nationality"
                label-cols-sm="3"
                :valid-feedback="validFeedbackNationality"
                :invalid-feedback="invalidFeedbackNationality"
                :state="stateNationality"
              >
                <b-form-select
                  v-model="form.m_Nationality"
                  :options="nationality"
                  size="md"
                  id="m_Nationality"
                  required
                >
                  <b-form-select-option :value="null" disabled
                    >-- สัญชาติ --</b-form-select-option
                  >
                </b-form-select>
              </b-form-group>
            </b-col>

            <b-col sm="6">
              <b-form-group
                id="m_PostalCode"
                label="รหัสไปรษณีย์: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-m_PostalCode"
                :valid-feedback="validFeedbackZipcode"
                :invalid-feedback="invalidFeedbackZipcode"
                :state="stateZipcode"
              >
                <b-form-select
                  v-model="form.m_Address.m_PostalCode"
                  :options="zipCode"
                  size="md"
                  id="m_PostalCode"
                  required
                >
                  <b-form-select-option :value="null" disabled
                    >-- รหัสไปรษณีย์ --</b-form-select-option
                  >
                </b-form-select>
              </b-form-group>
            </b-col>
          </b-row>

          <b-row>
            <b-col sm=6>
              <b-form-group
                id="m_Religion"
                label="ศาสนา: "
                label-align-sm="right"
                label-for="form-m_Religion"
                label-cols-sm="3"
                :valid-feedback="validFeedbackReligion"
                :invalid-feedback="invalidFeedbackReligion"
                :state="stateReligion"
              >
                <b-form-select
                  v-model="form.m_Religion"
                  :options="religion"
                  size="md"
                  id="m_Religion"
                  required
                >
                  <b-form-select-option :value="null" disabled
                    >-- ศาสนา --</b-form-select-option
                  >
                </b-form-select>
              </b-form-group>
            </b-col>
          </b-row>

          <b-row class="my-1">
            <b-col sm="6">
              <b-form-group
                id="m_Gender"
                label="เพศ: "
                label-align-sm="right"
                label-for="form-m_Gender"
                label-cols-sm="3"
                v-slot="{ ariaDescribedby }"
                :valid-feedback="validFeedbackGender"
                :invalid-feedback="invalidFeedbackGender"
                :state="stateGender"
              >
                <b-form-radio-group
                  v-model="form.m_Gender"
                  :options="gender"
                  :aria-describedby="ariaDescribedby"
                  name="radio-inline"
                  class="radio"
                ></b-form-radio-group
              ></b-form-group>
            </b-col>

            <b-col sm="6"> </b-col>
          </b-row>

          <b-row class="my-1">
            <b-col sm="6">
              <b-form-group
                id="m_Phonenumber"
                label="เบอร์โทรศัพท์: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-m_Phonenumber"
                :valid-feedback="validFeedbackTel"
                :invalid-feedback="invalidFeedbackTel"
                :state="stateTel"
              >
                <b-form-input
                  id="tel"
                  placeholder="เบอร์โทรศัพท์"
                  v-model="form.m_Phonenumber"
                  required
                >
                </b-form-input>
              </b-form-group>
            </b-col>
          </b-row>

          <b-row class="my-1">
            <b-col sm="6">
              <b-form-group
                id="m_Weight"
                label="น้ำหนัก: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-m_Weight"
                :valid-feedback="validFeedbackWeight"
                :invalid-feedback="invalidFeedbackWeight"
                :state="stateWeight"
              >
                <b-form-input
                  type="number"
                  id="m_Weight"
                  placeholder="0.00"
                  v-model="form.m_Weight"
                  required
                  min="1"
                >
                </b-form-input>
              </b-form-group>
            </b-col>

            <b-col>
              <label class="kg">กิโลกรัม</label>
            </b-col>
          </b-row>
          <b-row class="my-1">
            <b-col sm="6">
              <b-form-group
                id="m_Height"
                label="ส่วนสูง: "
                label-align-sm="right"
                label-cols-sm="3"
                label-for="form-m_Height"
                :valid-feedback="validFeedbackHeight"
                :invalid-feedback="invalidFeedbackHeight"
                :state="stateHeight"
              >
                <b-form-input
                  type="number"
                  id="m_Height"
                  placeholder="0.00"
                  v-model="form.m_Height"
                  min="1"
                  required
                >
                </b-form-input>
              </b-form-group>
            </b-col>

            <b-col><label class="cm">เซนติเมตร</label></b-col>
          </b-row>

          <b-row class="my-1">
            <b-col sm="6"> </b-col>
          </b-row>

          <b-row>
            <b-col>
              <b-navbar-nav class="float-right" id="areabtn">
                <b-nav-form>
                  <b-button
                    variant="success"
                    class="mr-6"
                    id="btnregister"
                    @click="handleSubmit()"
                    style="font-size:24px; padding:10px;"
                    >สมัครสมาชิก
                  </b-button>

                  <b-modal
                    id="modal-form-Applicant"
                    title="สมัครสมาชิกสำเร็จ"
                    okTitle="ตกลง"
                    ok-variant="success"
                    cancel-title="ยกเลิก"
                    cancel-variant="danger"
                    v-b-modal.modal-addApplicant
                    ref="modal-form-Applicant"
                  >
                    <img
                      src="https://cdn3.iconfinder.com/data/icons/flat-actions-icons-9/792/Tick_Mark_Dark-512.png"
                      alt="success"
                      width="80"
                      id="correct"
                    />
                    <p class="my-4" id="regitsuc">สมัครสมาชิกสำเร็จ</p>
                  </b-modal>
                </b-nav-form>

                <b-col class="login">
                  <b-card-text style="text-aling: center"
                    ><p>
                      เป็นสมาชิกอยู่แล้ว ? <b-link href="">เข้าสู่ระบบ</b-link>
                    </p></b-card-text
                  >
                </b-col>
              </b-navbar-nav>
            </b-col>
          </b-row>
        </b-card-body>
      </b-card>
    </b-container>
  </div>
</template>

<script>
import ApplicantService from '../Service/Applicants.js'
// import axios from 'axios'
export default {
  data () {
    return {
      applicantList: {},
      registerList: [],
      selected: null,
      value: '',
      province: [
        { value: 'Chonburi', text: 'ชลบุรี' },
        { value: 'Bangkok', text: 'กรุงเทพมหานคร' },
        { value: 'Ayuthaya', text: 'พระนครศรีอยุธยา' },
        { value: 'Rayong', text: 'ระยอง' }
      ],
      business: [
        { value: 'Stationery', text: 'ธุรกิจการกระดาษ/เครื่องเขียน' },
        { value: 'agriculture', text: 'ธุรกิจการเกษตร' },
        { value: 'publication', text: 'ธุรกิจการพิมพ์/สิ่งพิมพ์' },
        { value: 'education', text: 'ธุรกิจเพื่อการศึกษา' },
        { value: 'transport', text: 'ธุรกิจขนส่ง' },
        { value: 'electronic', text: 'ธุรกิจคอมพิวเตอร์/IT' }
      ],
      district: [
        { value: 'A', text: 'อำเภอเมือง' },
        { value: 'A', text: 'อำเภอแสนสุข' },
        { value: 'A', text: 'อำเภอบ้านบึง' },
        { value: 'A', text: 'อำเภอศรีราชา' },
        { value: 'A', text: 'อำเภอหนองใหญ่' },
        { value: 'A', text: 'อำเภอพนัสนิคม' }
      ],
      subdistrict: [
        { value: 'A', text: 'ตำบลบางปลาสร้อย' },
        { value: 'A', text: 'ตำบลคลองตำหรุ' },
        { value: 'A', text: 'ตำบลบางทราย' },
        { value: 'A', text: 'ตำบลสำนักบก' },
        { value: 'A', text: 'ตำบลบ้านสวน' },
        { value: 'A', text: 'ตำบลบ้านบึง' }
      ],
      zipCode: [
        { value: 'A', text: '20000' },
        { value: 'A', text: '20170' },
        { value: 'A', text: '20130' },
        { value: 'A', text: '20110' },
        { value: 'A', text: '20160' },
        { value: 'A', text: '20240' }
      ],
      nationality: [
        { value: 'A', text: 'ไทย' },
        { value: 'A', text: 'พม่า' },
        { value: 'A', text: 'ลาว' },
        { value: 'A', text: 'อเมริกา' },
        { value: 'A', text: 'อังกฤษ' },
        { value: 'A', text: 'เกาหลี' },
        { value: 'A', text: 'อื่นๆ' }
      ],
      religion: [
        { value: 'A', text: 'พุทธ' },
        { value: 'A', text: 'คริสต์' },
        { value: 'A', text: 'อิสลาม' }
      ],
      gender: [
        { text: 'ชาย', value: 'Men' },
        { text: 'หญิง', value: 'Women' }
      ],
      form: {
        id: -1,
        m_User: '',
        m_Firstname: '',
        m_Lastname: '',
        m_Password: '',
        Repassword: '',
        m_Email: '',
        m_Birthdate: '',
        m_Nationality: '',
        m_Religion: '',
        m_Weight: 0.0,
        m_Height: 0.0,
        m_Gender: '',
        m_Address: {
          m_Number: '',
          m_VillageNo: '',
          m_District: '',
          m_SubDistrict: '',
          m_Province: '',
          m_PostalCode: ''
        },
        m_Phonenumber: ''
      }
    }
  },
  // },
  methods: {
    addApplicant () {
      console.log('addApplicant')
      this.$bvModal.show('modal-form-Applicant')
      ApplicantService.addApplicant(this.form)
      console.log(ApplicantService.lastId)
      console.log(ApplicantService.getApplicants())
      this.resetModal()
    },
    resetModal () {
      this.form = {
        id: -1,
        m_User: '',
        m_Firstname: '',
        m_Lastname: '',
        m_Password: '',
        Repassword: '',
        m_Email: '',
        m_Birthdate: '',
        m_Nationality: '',
        m_Religion: '',
        m_Weight: 0.0,
        m_Height: 0.0,
        m_Gender: '',
        m_Address: {
          m_Number: '',
          m_VillageNo: '',
          m_District: '',
          m_SubDistrict: '',
          m_Province: '',
          m_PostalCode: ''
        },
        m_Phonenumber: ''
      }
    },
    handleOk (bvModalEvt) {
      // Prevent modal from closing
      bvModalEvt.preventDefault()
      // Trigger submit handler
      this.handleSubmit()
    },
    handleSubmit () {
      // alert ("Form submitted!")
      if (
        this.stateName === false ||
        this.stateAddress === false ||
        this.statePassword === false ||
        this.stateRepassword === false ||
        this.stateEmail === false ||
        this.stateNameCom === false ||
        this.stateBusiness === false ||
        this.stateSecurity === false ||
        this.stateContactName === false ||
        this.stateRegister === false
      ) {
        return ''
      }
      this.addApplicant()
    },
    checkDate (checkMonth, checkDay) {
      if (
        checkMonth === 1 ||
        checkMonth === 3 ||
        checkMonth === 5 ||
        checkMonth === 7 ||
        checkMonth === 8 ||
        checkMonth === 10 ||
        checkMonth === 12
      ) {
        console.log('month ', checkMonth)
        if (checkDay > 0 && checkDay <= 31) {
          console.log('day ', checkDay)
          this.birthdayValue = true
        } else {
          console.log('error day ', checkDay)
          this.birthdayValue = false
        }
      } else if (
        checkMonth === 4 ||
        checkMonth === 6 ||
        checkMonth === 9 ||
        checkMonth === 11
      ) {
        console.log('month ', checkMonth)
        if (checkDay > 0 && checkDay <= 30) {
          console.log('day ', checkDay)
          this.birthdayValue = true
        } else {
          console.log('error day ', checkDay)
          this.birthdayValue = false
        }
      } else if (checkMonth === 2) {
        console.log('month ', checkMonth)
        if (checkDay > 0 && checkDay <= 29) {
          console.log('day ', checkDay)
          this.birthdayValue = true
        } else {
          console.log('error day ', checkDay)
          this.birthdayValue = false
        }
      } else {
        console.log('error month')
        this.birthdayValue = false
      }
    }
  },
  computed: {
    stateUsername () {
      return this.form.m_User.length >= 10 && this.form.m_User.length <= 16
    },
    invalidFeedbackUsername () {
      if (this.form.m_User.length >= 10 && this.form.m_User.length <= 16) {
        return 'กรุณากรอกชื่อผู้ใช้งานอย่างน้อย 10-16 ตัวอักษร'
      } else if (this.form.m_User.length > 16) {
        return 'กรุณากรอกชื่อผู้ใช้งาน 10-16 ตัวอักษร'
      } else {
        return 'กรุณากรอกชื่อผู้ใช้งาน'
      }
    },
    validFeedbackUsername () {
      return this.stateUsername === true ? 'สำเร็จ' : ''
    },
    stateName () {
      return this.form.m_Firstname.length >= 3
    },
    invalidFeedbackName () {
      if (this.form.m_Firstname.length > 3) {
        return ''
      } else if (this.form.m_Firstname.length > 0) {
        return 'กรุณากรอกชื่ออย่างน้อย 3 ตัวอักษร'
      } else {
        return 'กรุณากรอกชื่อ'
      }
    },
    validFeedbackName () {
      return this.stateName === true ? 'สำเร็จ' : ''
    },
    stateSurname () {
      return this.form.m_Lastname.length >= 3
    },
    invalidFeedbackSurname () {
      if (this.form.m_Lastname.length > 3) {
        return ''
      } else if (this.form.m_Lastname.length > 0) {
        return 'กรุณากรอกนามสกุลอย่างน้อย 3 ตัวอักษร'
      } else {
        return 'กรุณากรอกนามสกุล'
      }
    },
    validFeedbackSurname () {
      return this.stateSurname === true ? 'สำเร็จ' : ''
    },
    statePassword () {
      return (
        this.form.m_Password.length >= 8 && this.form.m_Password.length <= 16
      )
    },
    invalidFeedbackPassword () {
      if (this.form.m_Password.length > 8) {
        return ''
      } else if (
        this.form.m_Password.length > 8 &&
        this.form.m_Password.length <= 16
      ) {
        return 'กรุณากรอกรหัสผ่านงานอย่างน้อย 8 ตัวอักษร แต่น้อยกว่า 16 ตัวอักษร'
      } else {
        return 'กรุณากรอกรหัสผ่าน'
      }
    },
    validFeedbackPassword () {
      return this.statePassword === true ? 'สำเร็จ' : ''
    },
    stateRepassword () {
      return (
        this.form.Repassword === this.form.m_Password &&
        this.form.Repassword.length >= 8 &&
        this.form.Repassword.length <= 16
      )
    },
    invalidFeedbackRepassword () {
      if (this.form.Repassword !== this.form.m_Password) {
        return 'กรุณากรอกรหัสผ่านให้ตรงกัน'
      } else if (this.form.Repassword !== null) {
        return 'กรุณากรอกรหัสผ่านยืนยันรหัสผ่าน'
      } else {
        return 'กรุณากรอกรหัสผ่านยืนยันรหัสผ่าน'
      }
    },
    validFeedbackRepassword () {
      return this.stateRepassword === true ? 'สำเร็จ' : ''
    },
    stateTel () {
      return this.form.m_Phonenumber.length === 10
    },
    invalidFeedbackTel () {
      if (this.form.m_Phonenumber.length > 0) {
        return 'กรุณากรอกตัวเลข 10 ตัวอักษร'
      } else if (this.form.m_Phonenumber.length > 0) {
        return 'กรุณากรอกตัวเลข 10 ตัวอักษร'
      }
      return 'กรุณากรอกเบอร์โทรศัพท์'
    },
    validFeedbackTel () {
      return this.stateTel === true ? 'สำเร็จ' : ''
    },
    stateEmail () {
      return /^\w+([\\.-]?\w+)@\w+([\\.-]?\w+)(.\w{2,3})+$/.test(
        this.form.m_Email
      )
    },
    invalidFeedbackEmail () {
      if (this.form.m_Email.length === 0) {
        return 'กรุณากรอกอีเมล'
      } else if (
        this.form.m_Email !== /^\w+([\\.-]?\w+)@\w+([\\.-]?\w+)(.\w{2,3})+$/
      ) {
        return 'กรุณากรอกอีเมลให้ถูกต้อง'
      } else {
        return ''
      }
    },
    validFeedbackEmail () {
      return this.stateEmail === true ? 'สำเร็จ' : ''
    },
    stateNationality () {
      return this.form.m_Nationality.length === 1
    },
    invalidFeedbackNationality () {
      if (this.form.m_Nationality.length > 0) {
        return 'กรุณาเลือกสัญชาติ'
      } else {
        return 'กรุณาเลือกสัญชาติ'
      }
    },
    validFeedbackNationality () {
      return this.stateNationality === true ? 'สำเร็จ' : ''
    },
    stateReligion () {
      return this.form.m_Religion.length === 1
    },
    invalidFeedbackReligion () {
      if (this.form.m_Religion.length > 0) {
        return 'กรุณาเลือกศาสนา'
      } else {
        return 'กรุณาเลือกศาสนา'
      }
    },
    validFeedbackReligion () {
      return this.stateReligion === true ? 'สำเร็จ' : ''
    },
    stateAddress () {
      return this.form.m_Address.m_Number !== ''
    },
    invalidFeedbackAddress () {
      if (this.form.m_Address.m_Number === '') {
        return 'กรุณากรอกบ้านเลขที่'
      } else {
        return 'กรุณากรอกบ้านเลขที่'
      }
    },
    validFeedbackAddress () {
      return this.stateAddress === true ? 'สำเร็จ' : ''
    },
    stateZipcode () {
      return this.form.m_Address.m_PostalCode.length === 1
    },
    invalidFeedbackZipcode () {
      if (this.form.m_Address.m_PostalCode.length > 0) {
        return 'กรุณากรอกรหัสไปรษณีย์ มากกว่า 2 ตัวอักษร'
      } else {
        return 'กรุณาเลือกรหัสไปรษณีย์'
      }
    },
    validFeedbackZipcode () {
      return this.stateZipcode === true ? 'สำเร็จ' : ''
    },
    stateProvince () {
      return this.form.m_Address.m_Province.length === 1
    },
    invalidFeedbackProvince () {
      if (this.form.m_Address.m_Province.length > 0) {
        return 'กรุณากรอกจังหวัด มากกว่า 2 ตัวอักษร'
      } else {
        return 'กรุณาเลือกจังหวัด'
      }
    },
    validFeedbackProvince () {
      return this.stateProvince === true ? 'สำเร็จ' : ''
    },
    stateDistrict () {
      return this.form.m_Address.m_District.length === 1
    },
    invalidFeedbackDistrict () {
      if (this.form.m_Address.m_District.length > 0) {
        return 'กรุณากรอกอำเภอ มากกว่า 2 ตัวอักษร'
      } else {
        return 'กรุณาเลือกอำเภอ'
      }
    },
    validFeedbackDistrict () {
      return this.stateDistrict === true ? 'สำเร็จ' : ''
    },
    stateSubdistrict () {
      return this.form.m_Address.m_SubDistrict.length === 1
    },
    invalidFeedbackSubdistrict () {
      if (this.form.m_Address.m_SubDistrict.length > 0) {
        return 'กรุณากรอกตำบล มากกว่า 2 ตัวอักษร'
      } else {
        return 'กรุณาเลือกตำบล'
      }
    },
    validFeedbackSubdistrict () {
      return this.stateSubdistrict === true ? 'สำเร็จ' : ''
    },
    stateWeight () {
      return this.form.m_Weight !== 0
    },
    invalidFeedbackWeight () {
      if (this.form.m_Weight === 0) {
        return 'กรุณากรอกน้ำหนัก'
      } else {
        return 'กรุณากรอกน้ำหนัก'
      }
    },
    validFeedbackWeight () {
      return this.stateWeight === true ? 'สำเร็จ' : ''
    },
    stateHeight () {
      return this.form.m_Height !== 0
    },
    invalidFeedbackHeight () {
      if (this.form.m_Height === 0) {
        return 'กรุณากรอกส่วนสูง'
      } else {
        return 'กรุณากรอกส่วนสูง'
      }
    },
    validFeedbackHeight () {
      return this.stateHeight === true ? 'สำเร็จ' : ''
    },
    stateGender () {
      return this.form.m_Gender !== ''
    },
    invalidFeedbackGender () {
      if (this.form.m_Gender === '') {
        return 'กรุณาเลือกเพศ'
      } else {
        return 'กรุณาเลือกเพศ'
      }
    },
    validFeedbackGender () {
      return this.stateGender === true ? 'สำเร็จ' : ''
    },
    stateBirthday () {
      const currentDate = new Date()
      console.log('Current date:', currentDate)
      const year =
        currentDate.getFullYear() -
        parseInt(this.form.m_Birthdate.substring(0, 4))
      let month = 0
      if (this.form.m_Birthdate[5] === '0') {
        month = parseInt(this.form.m_Birthdate[6])
      } else {
        month = parseInt(this.form.m_Birthdate.substring(5, 7))
      }
      let day = 0
      if (this.form.m_Birthdate[8] === '0') {
        day = parseInt(this.form.m_Birthdate[9])
      } else {
        day = parseInt(this.form.m_Birthdate.substring(8))
      }
      this.checkDate(month, day)
      return (
        this.form.m_Birthdate.length === 10 &&
        this.form.m_Birthdate[4] === '-' &&
        this.form.m_Birthdate[7] === '-' &&
        year <= 60 &&
        year >= 20 &&
        this.birthdayValue === true
        // can't validate current date
      )
    },
    invalidFeedbackBirthday () {
      const currentDate = new Date()
      console.log('Current date:', currentDate)
      const year =
        currentDate.getFullYear() -
        parseInt(this.form.m_Birthdate.substring(0, 4))
      let month = 0
      if (this.form.m_Birthdate[5] === '0') {
        month = parseInt(this.form.m_Birthdate[6])
      } else {
        month = parseInt(this.form.m_Birthdate.substring(5, 7))
      }
      let day = 0
      if (this.form.m_Birthdate[8] === '0') {
        day = parseInt(this.form.m_Birthdate[9])
      } else {
        day = parseInt(this.form.m_Birthdate.substring(8))
      }
      console.log('year: ' + year + 'month: ' + month + ' day: ' + day)
      if (
        this.form.m_Birthdate.length === 10 &&
        this.form.m_Birthdate[4] === '-' &&
        this.form.m_Birthdate[7] === '-'
      ) {
        if (year >= 20 && year <= 60) {
          if (
            month === 1 ||
            month === 3 ||
            month === 5 ||
            month === 7 ||
            month === 8 ||
            month === 10 ||
            month === 12
          ) {
            console.log('month ', month)
            if (day > 0 && day <= 31) {
              console.log('day ', day)
              return ''
            } else {
              console.log('error day ', day)
              return 'กรุณากรอกวันใหม่อีกครั้ง'
            }
          } else if (
            month === 4 ||
            month === 6 ||
            month === 9 ||
            month === 11
          ) {
            console.log('month ', month)
            if (day > 0 && day <= 30) {
              console.log('day ', day)
              return ''
            } else {
              console.log('error day ', day)
              return 'กรุณากรอกวันใหม่อีกครั้ง'
            }
          } else if (month === 2) {
            console.log('month ', month)
            if (day > 0 && day <= 29) {
              console.log('day ', day)
              return ''
            } else {
              console.log('error day ', day)
              return 'กรุณากรอกวันใหม่อีกครั้ง'
            }
          } else {
            console.log('error month')
            return 'กรุณากรอกเดือนใหม่อีกครั้ง'
          }
        } else {
          return 'กรุณากรอกปีใหม่อีกครั้ง'
        }
      } else if (this.form.m_Birthdate.length > 0) {
        return "กรุณากรอกให้ตรง'YYYY-MM-DD'"
      } else if (this.form.m_Birthdate.length === 0) {
        return 'กรุณากรอกวันเกิด'
      }
      return ''
    },
    validFeedbackBirthday () {
      return this.stateBirthday === true ? 'สำเร็จ' : ''
    }
  },
  mounted () {
    console.log("vue is Applicant's register")
  }
}
</script>
<style>
@import '../css/ApplicantRegister.css';
</style>
